﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace eSkin4Common
{
    /// <summary>
    /// Base class for MQTT messages
    /// </summary>
    public class BaseMQTTMessage
    {
        /// <summary>
        /// The message type: the message class name.
        /// </summary>
        public string Type
        {
            get
            {
                return this.GetType().Name;
            }
        }

        /// <summary>
        /// The origin of the message: the machine name.
        /// </summary>
        public string Source
        {
            get
            {
                return Environment.MachineName;
            }
        }

        /// <summary>
        /// A timestamp for the message.
        /// </summary>
        public string Timestamp
        {
            get
            {
                return DateTime.Now.ToString("o");
            }
        }
    }
}
